<?php
defined('_JEXEC') or die( 'Restricted access' );
jimport( 'joomla.application.component.model' );

class MaxxGalleryModelCategories extends JModel{
    
    public function __construct(){
        parent::__construct();
    }
    
    public function getCategories($param=''){
        $db    =& JFactory::getDBO();        
        $query="select C.*, C.cid as id  from #__maxxgallery_cat AS C order by ordering";
        $db->setQuery( $query);
        return $db->loadObjectList($param);
    }
    
    public function buildTree($param=''){
        $mainframe =& JFactory::getApplication();
        $option = $mainframe->scope;
        $db    =& JFactory::getDBO();
        
        $filter_order        = $mainframe->getUserStateFromRequest('articleelement.filter_order', 'filter_order',   'ordering',    'cmd');
        $filter_order_Dir    = $mainframe->getUserStateFromRequest('articleelement.filter_order_Dir', 'filter_order_Dir', 'asc',  'word');
        if($filter_order!='ordering' ){
            $filter_order='ordering';
            $filter_order_Dir='asc';
        }
          
        $query="select C.*, C.cid as id  from #__maxxgallery_cat AS C order by parent asc, $filter_order $filter_order_Dir";
        $db->setQuery( $query);
        $all_cats = $db->loadObjectList($param);
        
        $categories = array();
        if(count($all_cats)) {
            foreach ($all_cats as $key => $value) {
                if(!$value->parent){
                    $this->recurseTree($value, 0, $all_cats, $categories, $is_select);
                }
            }
        }
        
        return $categories;
    }
    
    public function recurseTree($cat, $level, $all_cats, &$categories, $is_select) {
        $probil = '';
        
        $cat->level = $level;
        $categories[] = $cat;
        
        foreach ($all_cats as $categ) {
            if($categ->parent == $cat->id) {
                $this->recurseTree($categ, ++$level, $all_cats, $categories, $is_select);
                $level--;
            }
        }
        return $categories;
    }
    
    public function getCategory($id){
        $db =& JFactory::getDBO();     
        $query = 'SELECT * FROM #__maxxgallery_cat where cid="'.$db->getEscaped($id).'"';
        $db->setQuery( $query);
        $list = $db->loadObject();        
        return $list;
    }
    
    public  function getTotal(){
        $db    =& JFactory::getDBO();
        
        $query = 'SELECT COUNT(*)'
            . ' FROM #__maxxgallery_cat';
        $db->setQuery( $query );
        $total = $db->loadResult();
        
        return $total;
    }
    
    public function SortCatArray($a, $b) {
          return strcmp($a->name, $b->name);
        }
        
    public function ShowSelectCategoryList($cat, $cname = "catid", $extra = null, $orig = null ){
        $mainframe =& JFactory::getApplication();
        
        $listCat=$this->getCategories("cid");
        $output = "<select name=\"$cname\" class=\"inputbox\" $extra >\n";
        $output .= "  <option value=\"0\">Select</option>\n";
        if (count( $listCat ) == 0) {
          $output .= "</select>\n";
          return $output;
        }
        $ready=array();
        foreach($listCat as $key => $curr){
           $parent=$curr->parent;
          
            if ($parent != 0) {
                if (in_array($parent,$ready)) {
                  $listCat[$key]->name = $listCat[$parent]->name . ' &raquo; ' . $listCat[$key]->name;
                }
                else {
                  while ($parent != 0) {
                    $listCat[$key]->name = $listCat[$parent]->name . ' &raquo; ' . $listCat[$key]->name;
                    if (in_array($parent,$ready)) {
                      break;
                    }
                    else {
                      $parent = $listCat[$parent]->parent;
                    }
                  }
                }
              }
              $ready[$key] = 1;     
        }
        usort( $listCat, array($this,"SortCatArray") );
        foreach ($listCat as $key => $curr) {
            $output .= "<option value=\"" . $curr->cid . "\"";
            if ($cat == $curr->cid) {
              $output .= " selected=\"selected\"";
            }
            $output .= ">" . $curr->name . "</option>\n";
        }
        $output .= "</select>\n";
        return $output;
    }
    
    public function getPreviewCategory($id){
        $db    =& JFactory::getDBO();
        $db->setQuery(" select id, imgthumbsname from #__maxxgallery where catid='".$id."' ");
        $rowsT = $db->loadObjectList();
        foreach($rowsT as $curr){
          $temp[$curr->id]=$curr->imgthumbsname;
        }
        
        return $temp;
    }
    
    public function getGroups(){
        $db    =& JFactory::getDBO();
        $db->setQuery("select id as value, name as text from #__groups order by id");
        $groups = $db->loadObjectList();
        
        return $groups;
    }
    
    public function showParentCategoryList($idParent){
        $db    =& JFactory::getDBO();
        $res=''; $resT='';
        while($idParent){
            $query="select name, parent from #__maxxgallery_cat where cid=".$idParent."";
            $db->setQuery($query);
            $row = $db->loadAssoc();
            if($row['parent']){
                $idParent=$row['parent'];
                $resT=$res;
                if($resT!='')
                    $res=$row['name'].'>>'.$resT;
                else
                    $res=$row['name'];
            }else{
                $idParent=0;
                $resT=$res;
                if($resT!='')
                    $res=$row['name'].'>>'.$resT;
                else
                    $res=$row['name'];
                //die();
            }
        }
        return $res;
    }
     
    public function saveOrder($cid, $order){
        $db =& JFactory::getDBO();
        for ($i=0; $i<count($cid); $i++){
            $query = 'UPDATE #__maxxgallery_cat SET ordering = '.(int) $order[$i] . ' WHERE cid='.$cid[$i].'';
            $db->setQuery( $query );
            if (!$db->query()){
                JError::raiseError(500, $db->getErrorMsg() );
            }
        }
        return true;
    }
    
    public function saveCategory($post){            
        $db =& JFactory::getDBO();
        if (!$post['id']){
            $queryOr = "select max(ordering) from #__maxxgallery_cat where `parent`='".$db->getEscaped($post['catid'])."'";
            $db->setQuery($queryOr);
            $ebdordering = $db->loadResult();
            $post['ordering'] = $ebdordering + 1;
            $query = "insert into #__maxxgallery_cat set name='".$db->getEscaped($post['name'])."', parent='".$post['catid']."', description='".Addslashes(trim($post['description']))."', ordering='".$post['ordering']."', access='".$post['access']."', published='".$post['published']."'";
        }else{
            $query = "update  #__maxxgallery_cat set name='".$db->getEscaped($post['name'])."', parent='".$post['catid']."', description='".Addslashes(trim($post['description']))."', access='".$post['access']."', published='".$post['published']."', thumbs='".$post['thumbs']."'  where cid=".$post['id']."";
        }

        $db->setQuery( $query );
        if (!$db->query()){
            JError::raiseError(500, $db->getErrorMsg() );
        }else{
            return true;
        }
    }
    
    public function _getLists()
    {
        $mainframe=JFactory::getApplication();

        $filter_order        = $mainframe->getUserStateFromRequest('articleelement.filter_order',        'filter_order',        'ordering',    'cmd');
        $filter_order_Dir    = $mainframe->getUserStateFromRequest('articleelement.filter_order_Dir',    'filter_order_Dir',    'asc',    'word');

        $lists['order_Dir']    = $filter_order_Dir;
        $lists['order']        = $filter_order;

        return $lists;
    }
}
?>