<?php
defined('_JEXEC') or die('Restricted access');
jimport('joomla.application.component.controller');

class maxxGalleryControllerPictures extends JController
{

    public function __construct( $default = array() ){        
        parent::__construct( $default );
        $task = JRequest::getVar('task');
        $layout = JRequest::getVar('layout');     
        if($task=='add')
            MaxxgalleryHelper::addSubmenu("upload");  
        elseif($layout=='batch')
            MaxxgalleryHelper::addSubmenu("batch");  
        else
            MaxxgalleryHelper::addSubmenu("picture");  
        $this->registerTask('apply',    'save');
    }
    
    public function display(){
        $mainframe =& JFactory::getApplication();
        ini_set("upload_max_filesize", "100M");
        $cid = JRequest::getVar( 'cid', array(0), '', 'array' );
                          
        $view = JRequest::getVar('view', 'maxxgallery');
        $layout = JRequest::getVar('layout');  
        $view = $this->getView( $view,'html'); 
        
        if ($modelP = &$this->getModel('pictures')) {
        // Push the model into the view (as default)
            $view->setModel($modelP);
        }
        if ($modelCA = &$this->getModel('categories')) {
        // Push the model into the view (as default)
            $view->setModel($modelCA);
        }
        
        if(JRequest::getVar('task')=='add' || JRequest::getVar('task')=='edit'){
            if(JRequest::getVar('view')=='pictures'){
                if($cid[0])
                    $view->display('formedit');  
                else
                    $view->display('formupload');
            }
        }else{
            $view->display($layout);    
        }   
    }
    
    public function unpublish(){
        $cid = JRequest::getVar( 'cid', array(0), '', 'array' );
        $view = JRequest::getVar('view');
        $this->publishPic('unpublish');
    }
    
    public function publish() {
        $cid = JRequest::getVar( 'cid', array(0), '', 'array' );
        $view = JRequest::getVar('view');
        $this->publishPic('publish');
    }
    
    public function publishPic($task){
        // Check for request forgeries
        JRequest::checkToken() or jexit( 'Invalid Token' );
        $db        =& JFactory::getDBO();
        $cid     = JRequest::getVar( 'cid', array(0), 'post', 'array' );
        JArrayHelper::toInteger($cid, array(0));
        $publish = ( $task == 'publish' ? 1 : 0 );
        if (count( $cid ) < 1) {
            $action = $publish ? JText::_( 'publish' ) : JText::_( 'unpublish' );
            JError::raiseError(500, JText::_( 'Select a image to '.$action ) );
        }
        $cids = implode( ',', $cid );
        $query = 'UPDATE #__maxxgallery SET published = '.(int) $publish . ' WHERE id IN ( '.$cids.' )';
        
        $db->setQuery( $query );
        if (!$db->query()) {
            JError::raiseError(500, $db->getErrorMsg() );
        }

        $this->setRedirect( 'index.php?option=com_maxxgallery&controller=pictures&view=pictures',JTEXT::_('MAXX_SUCCESS'));
    }
    
    public function orderup(){
        $cid = JRequest::getVar( 'cid', array(0), '', 'array' );        
        $this->_orderPic(intval($cid[0]), -1);
    }
    
    public function orderdown(){
        $cid = JRequest::getVar( 'cid', array(0), '', 'array' );        
        $this->_orderPic(intval($cid[0]), 1);
    }
    
    public function _orderPic($uid, $move){
        $obj = &JTable::getInstance('picture', 'maxxgallery');
        $obj->load($uid);
        $obj->move($move,"catid='".$obj->catid."'");        
        $this->setRedirect('index.php?option=com_maxxgallery&controller=pictures&view=pictures');
    }
    
    public function saveorder(){ 
        $cid = JRequest::getVar( 'cid', array(0), '', 'array' ); 
        $model = &$this->getModel('pictures');
        $order = JRequest::getVar( 'order', array(0), 'post', 'array' );
        
        if ($model->saveOrder($cid,$order))
            $this->setRedirect('index.php?option=com_maxxgallery&controller=pictures&view=pictures',JTEXT::_('MAXX_SUCCESS'));
    }
    
    public function save(){
        $cid = JRequest::getVar( 'cid', '0', 'post', 'int' );
        $view = JRequest::getVar('view');
        IF($_POST['id']){
            $this->saveEditPic($cid);
        }else{
            $this->saveUpload();
        }  
    }
    
    public function saveUpload(){
        $mainframe =& JFactory::getApplication();
        ini_set("memory_limit", "400M");
        ini_set("max_execution_time", "0");
        ini_set("post_max_size", "100M");
        ini_set("upload_max_filesize", "100M");
        
        $model = $this->getModel('pictures');
        include('../administrator/components/com_maxxgallery/maxx.config.php');

        $post = JRequest::get('post');
        $post['imgtitle']  = JRequest::getVar('imgtitle','','post',"string", 2);
        $post['imgtext']   = JRequest::getVar('imgtext','','post',"string", 2);
        $post['filename']  = JRequest::getVar('filename','','post',"string", 2);
        $post['imgauthor'] = JRequest::getVar('imgauthor','','post',"string", 2);
        
        $handle = new upload($_FILES['img']); 
        
        if ($handle->uploaded) {
            $handle->jpeg_quality         = $maxx_thumbquality;
            if($post['filename']!=''){
                $handle->file_new_name_body   = $post['filename'];
            }else
                $handle->file_new_name_body   = $handle->file_name_body_pre;
            $handle->file_auto_rename           = true;
                      
            $handle->file_src_size              = 400000;
        }
        $handle->allowed= array('image/*');
        $handle->Process(JPATH_SITE.$maxx_path.DS);
        $name=$handle->file_dst_name_body;

        if($handle->processed==1){
            
            $post['imgoriginalname']=$handle->file_dst_name;
            $post['imgfilename']=$handle->file_dst_name;
            $post['imgthumbsname']=$handle->file_dst_name;
            $insID=$model->savePicture($post);
            
            if ($insID) {
                //create thumbs picture
                $handle->image_resize               = true;
                $handle->image_ratio_crop           = 'C';
                if($maxx_thumbwidth!=0 && $maxx_thumbheight!=0){
                $handle->image_x                    = $maxx_thumbwidth;
                $handle->image_y                    = $maxx_thumbheight;
                }elseif($maxx_thumbwidth==0){
                    $handle->image_ratio_x              = true;
                    $handle->image_y                    = $maxx_thumbheight;
                }elseif($maxx_thumbheight==0){
                    $handle->image_ratio_y              = true;
                    $handle->image_x                    = $maxx_thumbwidth;
                }
                        
                $handle->file_auto_rename           = false;
                $handle->file_overwrite             = true;   
                $handle->file_new_name_body         = $name;           
                $handle->jpeg_quality               = $maxx_thumbquality;
                $handle->Process(JPATH_SITE.$maxx_paththumbspictures.DS);
                
                ////create view picture              
                $handle->image_resize               = true;
                if($handle->image_src_x > $handle->image_src_y){
                    $handle->image_ratio_y              = true;
                    $handle->image_x                    = $maxx_maxwidth;
                }else{
                    $handle->image_ratio_x              = true;
                    $handle->image_y                    = $maxx_maxheight;  
                }
               
                
                $handle->file_auto_rename           = false;
                $handle->file_overwrite             = true; 
                $handle->file_new_name_body         = $name; 
                $handle->jpeg_quality         = $maxx_thumbquality;             
                $handle->Process(JPATH_SITE.$maxx_pathpictures.DS);

                if($maxx_watermarks)
                    $this->makewatermark($name,$handle->file_dst_name);
                                
                if($maxx_cutoriginal){
                    if($handle->image_src_x > $maxx_orgwidth or $handle->image_src_y > $maxx_orgheight){
                        $handle->image_resize                   = true;
                        if($handle->image_src_x > $handle->image_src_y){
                            $handle->image_ratio_y              = true;
                            $handle->image_x                    = $maxx_orgwidth;
                            $handle->file_auto_rename           = false;
                            $handle->file_overwrite             = true;
                            $handle->file_new_name_body         = $name;
                            $handle->jpeg_quality               = $maxx_thumbquality;
                            $handle->Process(JPATH_SITE.$maxx_path.DS);
                        }elseif($imginfo[0]<=$imginfo[1]){
                            $handle->image_ratio_x              = true;
                            $handle->image_y                    = $maxx_orgheight;
                            $handle->file_auto_rename           = false;
                            $handle->file_overwrite             = true;
                            $handle->file_new_name_body         = $name;
                            $handle->jpeg_quality               = $maxx_thumbquality;
                            $handle->Process(JPATH_SITE.$maxx_path.DS);
                        }                   
                    }
                } 
                $msg = JText::_( MAXX_UPLOAD_SUCCESS );
                
            } else {
                $msg = JText::_( MAXX_ERR_SAVE_DATABASE );
            }
        }else{
           $msg = JText::_(  $handle->error );
        }
        if(JRequest::getVar('task')!=apply)
            $link = 'index.php?option=com_maxxgallery&controller=pictures&view=pictures';
        else
            $link = 'index.php?option=com_maxxgallery&controller=pictures&task=edit&view=pictures&cid[]='.$insID;
        $this->setRedirect($link, $msg);
    }
    
    public function saveEditPic($cid){
        include('../administrator/components/com_maxxgallery/maxx.config.php');
        ini_set("max_execution_time", "0");
        ini_set('memory_limit','200M');
        $model = $this->getModel('pictures');
        $id= JRequest::getVar( 'id', '0', 'post', 'int' ); 
        
        
        $x= JRequest::getVar( 'x', '0', 'post', 'int' );    
        $y= JRequest::getVar( 'y', '0', 'post', 'int' );    
        $w= JRequest::getVar( 'w', '0', 'post', 'int' );    
        $h= JRequest::getVar( 'h', '0', 'post', 'int' );
        
        $saveThumbs = JRequest::getInt('saveThumbs','0');   
        $saveWatermark = JRequest::getInt('saveWatermark','0');   
        $imgfilename = trim(JRequest::getVar('imgfilename'));
        $filename    = trim(JRequest::getVar('filename'));

        $post = JRequest::get('post');
        $post['imgtitle']  = JRequest::getVar('imgtitle','','post',"string", 2);
        $post['imgtext']   = JRequest::getVar('imgtext','','post',"string", 2);
        $post['filename']  = JRequest::getVar('filename','','post',"string", 2);
        $post['imgauthor'] = JRequest::getVar('imgauthor','','post',"string", 2);

        $src = JPATH_SITE.$maxx_pathpictures.DS.$imgfilename;
              
        
        //save new thumbs       
        if($saveThumbs){
            if(file_exists($src)){
               ////create view picture 
                $handleV = new upload(JPATH_SITE.$maxx_path.DS.$imgfilename);             
                $handleV->image_resize               = true;
                if($handleV->image_src_x > $handleV->image_src_y){
                    $handleV->image_ratio_y              = true;
                    $handleV->image_x                    = $maxx_maxwidth;
                }else{
                    $handleV->image_ratio_x              = true;
                    $handleV->image_y                    = $maxx_maxheight;  
                }
                $handleV->file_auto_rename           = false;
                $handleV->file_overwrite             = true; 
                $handleV->jpeg_quality         = $maxx_thumbquality;             
                $handleV->Process(JPATH_SITE.$maxx_paththumbspictures.DS); 
            }
            $handle = new upload($src);
            $left = $x;
            $top = $y; 
            $x = $left + $w;
            $y = $top + $h;
            $right = $handle->image_src_x - $x;
            $bottom =  $handle->image_src_y - $y;
           
            $handle->image_resize        = true;
            $handle->file_overwrite      = true; 
            $handle->jpeg_quality        = $maxx_thumbquality;
            $handle->image_precrop       = array($top,$right,$bottom,$left); 
            
            $handle->image_resize               = true;
            if($maxx_thumbwidth!=0 && $maxx_thumbheight!=0){
                $handle->image_x                    = $maxx_thumbwidth;
                $handle->image_y                    = $maxx_thumbheight;
            }elseif($maxx_thumbwidth==0){
                $handle->image_ratio_x              = true;
                $handle->image_y                    = $maxx_thumbheight;
            }elseif($maxx_thumbheight==0){
                $handle->image_ratio_y              = true;
                $handle->image_x                    = $maxx_thumbwidth;
            }
            
            $handle->Process(JPATH_SITE.$maxx_paththumbspictures);
            
        }
        // save new picture with watermark
        if($saveWatermark){
            if(file_exists($src)){
                
                $water_src = JPATH_SITE.'/administrator/components/com_maxxgallery/images'.DS.$maxx_fileWatermark;
                list($watermarkIMG_width, $watermarkIMG_height, $watermarkIMG_type) = getimagesize($water_src); 
                list($width, $height, $type, $attr) = getimagesize($src);
                
                switch($maxx_position_watermark){
                    case '1':           //top right
                        $xWater = $width - $this->watermarkIMG_width - 10;
                        $yWater = 10;
                        break;
                    case '2':           //top left
                        $xWater = 10;
                        $yWater = 10;
                        break;
                    case '3':           //bottom right
                        $xWater = $width - $watermarkIMG_width - 10;
                        $yWater = $height - $watermarkIMG_height - 10;
                        break;
                    case '4':           // bottom left
                        $xWater = 10;
                        $yWater = $height - $watermarkIMG_height - 10;
                        break;
              }   

                //create view picture 
                $handleV = new upload(JPATH_SITE.$maxx_path.DS.$imgfilename);             
                $handleV->image_resize               = true;
                if($handleV->image_src_x > $handleV->image_src_y){
                    $handleV->image_ratio_y              = true;
                    $handleV->image_x                    = $maxx_maxwidth;
                }else{
                    $handleV->image_ratio_x              = true;
                    $handleV->image_y                    = $maxx_maxheight;  
                }
                $handleV->file_auto_rename           = false;
                $handleV->file_overwrite             = true; 
                $handleV->jpeg_quality         = $maxx_thumbquality;             
                $handleV->Process(JPATH_SITE.$maxx_pathpictures.DS); 
            }
            $handle = new upload($src);
            
               
            $handle->image_watermark      = $water_src;
            $handle->image_watermark_x    = $xWater;
            $handle->image_watermark_y    = $yWater;
            $handle->file_overwrite       = true;
            $handle->jpeg_quality         = $maxx_thumbquality;
            $handle->file_auto_rename = false;
            
            $handle->Process(JPATH_SITE.$maxx_pathpictures.DS);
                      
            $model->updateWatermark($xWater,$yWater,$id);
            
        }
        //rename picture if it is necessary
        
        if(substr($imgfilename,0,strpos($imgfilename,'.'))!=$filename || substr($imgfilename,0,strpos($imgfilename,'.'))!=$handle->file_dst_name){
            $handle = new upload($src);
            $handle->file_new_name_body = $filename;
            $handle->Process();
            $name=$handle->file_dst_name;
        
            if(file_exists(JPATH_SITE.$maxx_path.DS.$imgfilename))
                rename(JPATH_SITE.$maxx_path.DS.$imgfilename,JPATH_SITE.$maxx_path.DS.$name);
                    
            if(file_exists(JPATH_SITE.$maxx_pathpictures.DS.$imgfilename))
                rename(JPATH_SITE.$maxx_pathpictures.DS.$imgfilename,JPATH_SITE.$maxx_pathpictures.DS.$name);
            
            if(file_exists(JPATH_SITE.$maxx_paththumbspictures.DS.$imgfilename))
                rename(JPATH_SITE.$maxx_paththumbspictures.DS.$imgfilename,JPATH_SITE.$maxx_paththumbspictures.DS.$name);
                            
                        
            $post['imgoriginalname']=$name;
            $post['imgfilename']=$name;
            $post['imgthumbsname']=$name;
            $model->updatePicture($post); 
        }
            
        if($model->savePicture($post)){    
          if(JRequest::getVar('task')!=apply)
            $this->setRedirect( 'index.php?option=com_maxxgallery&controller=pictures&view=pictures',JTEXT::_('MAXX_SUCCESS'));
          else
            $this->setRedirect( 'index.php?option=com_maxxgallery&controller=pictures&task=edit&view=pictures&cid[]='.$id,JTEXT::_('MAXX_SUCCESS'));
        }else{ 
          $this->setRedirect( 'index.php?option=com_maxxgallery&controller=pictures&view=pictures',JTEXT::_('MAXX_ERR_SAVE_DATABASE'));
        }
    
    }
    
    public function batch(){
        ini_set("memory_limit", "400M");
        ini_set("max_execution_time", "0");
        ini_set("post_max_size", "100M");
        ini_set("upload_max_filesize", "100M");
        include_once('../administrator/components/com_maxxgallery/lib/zip.php');
        include('../administrator/components/com_maxxgallery/maxx.config.php');
        
        $model = $this->getModel('pictures');
        $handle = new upload($_FILES['zip']); 
        
        //$handle->allowed = array('application/zip', 'application/x-zip-compressed');
        $post=JRequest::get('post');
        $dir    = JPATH_SITE.$maxx_pathuploadzip;
        $handle->process($dir);
        
        
        
        if ($handle->processed==1){
            $nameZip=$handle->file_dst_name;
            //unzip archiv
            $zip=new Archive_Zip($dir.DS.$nameZip);
            $zipArray=$zip->extract(array('add_path'=>'../tempUnzip/'.$tmp['0']));
            $title=$post['imgtitle'];
            
            
            foreach($zipArray as $curr){
                $handle= new upload($curr['filename']);
                $handle->file_new_name_body = $post['filename'];
                $handle->Process(JPATH_SITE.$maxx_path.DS);
                $name=$handle->file_dst_name_body;
                
                $post['imgoriginalname']=$handle->file_dst_name;
                $post['imgfilename']=$handle->file_dst_name;
                $post['imgthumbsname']=$handle->file_dst_name;
                $post['imgtitle']=$title.'-'.$curr['index'];
                $insID=$model->savePicture($post);
                
                if ($insID) {
                    //create thumbs picture
                    $handle->image_resize               = true;
                    $handle->image_ratio_crop           = 'C';
                    if($maxx_thumbwidth!=0 && $maxx_thumbheight!=0){
                    $handle->image_x                    = $maxx_thumbwidth;
                    $handle->image_y                    = $maxx_thumbheight;
                    }elseif($maxx_thumbwidth==0){
                        $handle->image_ratio_x              = true;
                        $handle->image_y                    = $maxx_thumbheight;
                    }elseif($maxx_thumbheight==0){
                        $handle->image_ratio_y              = true;
                        $handle->image_x                    = $maxx_thumbwidth;
                    }
                    $handle->file_auto_rename           = false;
                    $handle->file_overwrite             = true;   
                    $handle->file_new_name_body         = $name;           
                    $handle->jpeg_quality               = $maxx_thumbquality;
                    $handle->Process(JPATH_SITE.$maxx_paththumbspictures.DS);
                                  
                     $handle->image_resize               = true;
                    if($handle->image_src_x > $handle->image_src_y){
                        $handle->image_ratio_y              = true;
                        $handle->image_x                    = $maxx_maxwidth;
                    }else{
                        $handle->image_ratio_x              = true;
                        $handle->image_y                    = $maxx_maxheight;  
                    }
                    $handle->file_auto_rename           = false;
                    $handle->file_overwrite             = true; 
                    $handle->file_new_name_body         = $name;             
                    $handle->Process(JPATH_SITE.$maxx_pathpictures.DS);
                    
                    if($maxx_watermarks)
                        $this->makewatermark($name,$handle->file_dst_name);
                                    
                    if($maxx_cutoriginal){
                        if($handle->image_src_x > $maxx_orgwidth or $handle->image_src_y > $maxx_orgheight){
                            $handle->image_resize                   = true;
                            if($handle->image_src_x > $handle->image_src_y){
                                $handle->image_ratio_y              = true;
                                $handle->image_x                    = $maxx_orgwidth;
                                $handle->file_auto_rename           = false;
                                $handle->file_overwrite             = true;
                                $handle->file_new_name_body         = $name;
                                $handle->jpeg_quality               = $maxx_thumbquality;
                                $handle->Process(JPATH_SITE.$maxx_path.DS);
                            }elseif($imginfo[0]<=$imginfo[1]){
                                $handle->image_ratio_x              = true;
                                $handle->image_y                    = $maxx_orgheight;
                                $handle->file_auto_rename           = false;
                                $handle->file_overwrite             = true;
                                $handle->file_new_name_body         = $name;
                                $handle->jpeg_quality               = $maxx_thumbquality;
                                $handle->Process(JPATH_SITE.$maxx_path.DS);
                            }                   
                        }
                    } 
                    $msg = JText::_( MAXX_UPLOAD_SUCCESS );
                    
                } else {
                    $msg = JText::_( MAXX_ERR_SAVE_DATABASE );
                }
                unlink($curr['filename']);
            }

            unlink($dir.'/'.$nameZip);
            rmdir(JPATH_SITE.'/tempUnzip/'.$tmp['0']);
            $MSG='Batch upload successfuly';
        }else{   
            $MSG=$handle->error; 
        }      
        
        $link = 'index.php?option=com_maxxgallery&controller=pictures&view=pictures';
        $this->setRedirect($link, $MSG); 
    }
    
    public function remove(){
        include('../administrator/components/com_maxxgallery/maxx.config.php');
        $cid     = JRequest::getVar( 'cid', array(0), 'post', 'array' );
        $cids = implode( ',', $cid );
        $db        =& JFactory::getDBO();
        $client  = JRequest::getWord( 'filter_client', 'site' );
        $query="select imgfilename from #__maxxgallery where id IN (".$cids.")";
        $db->setQuery( $query );
        $list=$db->loadObjectList();
        //print_r($list);
        foreach($list as $curr){
            if(file_exists(JPATH_SITE.$maxx_path.'/'.$curr->imgfilename))
                unlink(JPATH_SITE.$maxx_path.'/'.$curr->imgfilename);
            if(file_exists(JPATH_SITE.$maxx_paththumbspictures.'/'.$curr->imgfilename))
                unlink(JPATH_SITE.$maxx_paththumbspictures.'/'.$curr->imgfilename);
            if(file_exists(JPATH_SITE.$maxx_pathpictures.'/'.$curr->imgfilename))
                unlink(JPATH_SITE.$maxx_pathpictures.'/'.$curr->imgfilename);
            
            $query="select cid from #__maxxgallery_cat where thumbs='".$curr->imgfilename."'";
            $db->setQuery( $query );
            $idCat=$db->loadAssoc();
            if(count($idCat['cid'])){
                $query="select id,imgthumbsname from #__maxxgallery where catid=".$idCat['cid']." and imgthumbsname!='".$curr->imgfilename."' order by imgdate desc limit 0,1";
                $db->setQuery( $query );
                $idPic=$db->loadAssoc();
                if(count($idPic)){
                    $query="update #__maxxgallery_cat set thumbs='".$idPic['imgthumbsname']."' where cid=".$idCat['cid']."";
                    $db->setQuery( $query );
                    $db->query();
                }else{
                    $query="update #__maxxgallery_cat set published ='0' where cid=".$idCat['cid']."";
                    $db->setQuery( $query );
                    $db->query();
                }
            }
            
        }
        $query = 'delete from #__maxxgallery WHERE id IN ( '.$cids.' )';
        $db->setQuery( $query );
        
        
        if (!$db->query()) {
            JError::raiseError(500, $db->getErrorMsg() );
        }
        
        $this->setRedirect( 'index.php?option=com_maxxgallery&controller=pictures&view=pictures',JTEXT::_('MAXX_SUCCESS_REMOVE'));
    }
    
    public function makewatermark($name,$file){
        $mainframe =& JFactory::getApplication();
        
        include('../administrator/components/com_maxxgallery/maxx.config.php');
       
        if($file){
           
           $img=JPATH_SITE.$maxx_pathpictures.DS.$file;
           $handle = new upload($img); 
           $water=JPATH_SITE.DS.'administrator'.DS.'components'.DS.'com_maxxgallery'.DS.'images'.DS.$maxx_fileWatermark;
           $handle->jpeg_quality       = $maxx_thumbquality;
           list($watermarkIMG_width, $watermarkIMG_height, $watermarkIMG_type) = getimagesize($water);
           
           switch($maxx_position_watermark){
            case '1':           //top right
                $destIMG_x = $handle->image_src_x - $watermarkIMG_width - 10;
                $destIMG_y = 10;
                break;
            case '2':           //top left
                $destIMG_x = 10;
                $destIMG_y = 10;
                break;
            case '3':           //bottom right
                $destIMG_x = $handle->image_src_x - $watermarkIMG_width - 10;
                $destIMG_y = $handle->image_src_y - $watermarkIMG_height - 10;
                break;
            case '4':           // bottom left
                $destIMG_x = 10;
                $destIMG_y = $handle->image_src_y - $watermarkIMG_height - 10;
                break;
           }
                       
           $handle->image_watermark    = $water;
           $handle->image_watermark_x  = $destIMG_x;
           $handle->image_watermark_y  = $destIMG_y;
           $handle->file_auto_rename   = false;
           $handle->file_overwrite     = true; 
           $handle->file_new_name_body         = $name;
           $handle->Process(JPATH_SITE.$maxx_pathpictures.DS);   
        
        }
        
    }
    
    public function makeFoto($id=0){
        
         include('../administrator/components/com_maxxgallery/maxx.config.php');
            
         $db        =& JFactory::getDBO();
         if($id==0){
             $id=$_GET['id'];
         }
         $query="select imgoriginalname from #__maxxgallery where id='".$id."'";
        
         $db->setQuery($query);
         $list=$db->loadObject();
         $img=JPATH_SITE.$maxx_path.DS.$list->imgoriginalname;    
         $handle = new upload($img);
          
         $handle->image_resize               = true;
            if($handle->image_src_x > $handle->image_src_y){
                $handle->image_ratio_y              = true;
                $handle->image_x                    = $maxx_maxwidth;
            }else{
                $handle->image_ratio_x              = true;
                $handle->image_y                    = $maxx_maxheight;  
            }
         $handle->file_auto_rename           = false;
         $handle->file_overwrite             = true; 
         $handle->file_new_name_body         = $name; 
         $handle->jpeg_quality         = $maxx_thumbquality;
                    //print_r($handle);
          
          //die;
         //header('Content-type: ' . $handle->file_src_mime);
         // print_r($handle);
         echo $handle->Process();
         
         die();
    }
    
    
}//class